"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("../store/types");
var running = false;
function ErrorLogger() {
    return function (store) { return function (next) { return function (action) {
        if (action.type === types_1.updateGlobals && action.running !== undefined) {
            running = action.running;
        }
        else if (action.type === types_1.log) {
            var level = action.level, text = action.text;
            if (!running || level === 'warn' || level === 'error') {
                console.error(text);
            }
        }
        if (action.type === types_1.log && action.level !== 'error')
            return;
        return next(action);
    }; }; };
}
exports.default = ErrorLogger;
//# sourceMappingURL=errorLogger.js.map