"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require('path');
var os = require('os');
var fs = require('fs');
var spawn = require('threads').spawn;
var Server = /** @class */ (function () {
    function Server() {
        this.guid = 0;
    }
    Server.prototype.start = function (_a) {
        var _this = this;
        var binary = _a.binary, middleware = _a.middleware, config = __rest(_a, ["binary", "middleware"]);
        this.messages = {};
        this.thread = spawn(function (_a, send) {
            var args = _a[0];
            return __awaiter(_this, void 0, void 0, function () {
                var results, _b, Server_1, response, e_1;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            _c.trys.push([0, 13, , 14]);
                            results = undefined;
                            _b = args.task;
                            switch (_b) {
                                case 'start': return [3 /*break*/, 1];
                                case 'stop': return [3 /*break*/, 3];
                                case 'flush': return [3 /*break*/, 5];
                                case 'addUser': return [3 /*break*/, 7];
                                case 'removeUser': return [3 /*break*/, 8];
                                case 'createTask': return [3 /*break*/, 9];
                                case 'subscribe': return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 12];
                        case 1:
                            Server_1 = require(args.binary).default;
                            this.instance = new Server_1(args.config, args.middleware && require(args.middleware.binary).default(args.middleware.config));
                            // Start local CC server
                            return [4 /*yield*/, this.instance.start()];
                        case 2:
                            // Start local CC server
                            _c.sent();
                            return [3 /*break*/, 12];
                        case 3: return [4 /*yield*/, this.instance.stop(args.force)];
                        case 4:
                            _c.sent();
                            return [3 /*break*/, 12];
                        case 5: return [4 /*yield*/, this.instance.flush(args.force)];
                        case 6:
                            _c.sent();
                            return [3 /*break*/, 12];
                        case 7:
                            {
                                this.instance.actions.addUser(args.user);
                                return [3 /*break*/, 12];
                            }
                            _c.label = 8;
                        case 8:
                            {
                                this.instance.actions.removeUser(args.user);
                                return [3 /*break*/, 12];
                            }
                            _c.label = 9;
                        case 9: return [4 /*yield*/, this.instance.actions.createTask(args.command, args.user)];
                        case 10:
                            response = _c.sent();
                            results = Object.assign(response, { promise: undefined, reject: undefined, resolve: undefined });
                            return [3 /*break*/, 12];
                        case 11:
                            {
                                eval('var fn = ' + args.selector);
                                // @ts-ignore
                                this.instance.subscribe(fn, function (results) { return send({ id: args.id, results: results }); });
                                return [3 /*break*/, 12];
                            }
                            _c.label = 12;
                        case 12: return [2 /*return*/, { id: args.id, results: results }];
                        case 13:
                            e_1 = _c.sent();
                            console.error(e_1);
                            return [3 /*break*/, 14];
                        case 14: return [2 /*return*/];
                    }
                });
            });
        });
        this.thread.on('message', function (response) {
            if (response && _this.messages[response.id]) {
                var id = response.id, results = response.results;
                var _a = _this.messages[id], resolve = _a.resolve, callback = _a.callback;
                if (callback) {
                    if (results === undefined) {
                        resolve(results);
                    }
                    else {
                        callback(results);
                    }
                }
                else {
                    resolve(results);
                    delete _this.messages[id];
                }
            }
        });
        return this._task('start', __assign({ binary: binary, middleware: middleware }, config));
    };
    Server.prototype.stop = function (force) {
        if (force === void 0) { force = false; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._task('stop', { force: force })];
                    case 1:
                        _a.sent();
                        this.thread.kill();
                        return [2 /*return*/];
                }
            });
        });
    };
    Server.prototype.flush = function (force) {
        if (force === void 0) { force = false; }
        return this._task('flush', { force: force });
    };
    Server.prototype.addUser = function (user) {
        return this._task('addUser', { user: user });
    };
    Server.prototype.removeUser = function (user) {
        return this._task('removeUser', { user: user });
    };
    Server.prototype.createTask = function (command, user) {
        return this._task('createTask', { command: command, user: user });
    };
    Server.prototype.subscribe = function (selector, callback) {
        return this._task('subscribe', { selector: selector }, callback);
    };
    Server.prototype._task = function (task, args, callback) {
        var id = this.guid++;
        var resolve = undefined;
        // @ts-ignore
        var promise = new Promise(function (res) { return (resolve = res); });
        this.messages[id] = { resolve: resolve, callback: callback };
        this.thread.send([__assign(__assign({ task: task }, args), { id: id, selector: args.selector && args.selector.toString() })]);
        return promise;
    };
    return Server;
}());
exports.default = Server;
//# sourceMappingURL=threaded.js.map