"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.awaitState = exports.subscribe = void 0;
function subscribe(store, selector, callback) {
    var state = selector(store.getState());
    return store.subscribe(function () {
        var selected = selector(store.getState()), old = state;
        if (typeof selected === 'object' && !Array.isArray(selected)) {
            selected = Object.entries(selected).reduce(function (acc, _a) {
                var _b;
                var key = _a[0], value = _a[1];
                return (state[key] !== value ? __assign(__assign({}, acc), (_b = {}, _b[key] = value, _b)) : acc);
            }, state);
        }
        if (state !== selected)
            callback((state = selected), old);
    });
}
exports.subscribe = subscribe;
function awaitState(store, selector, condition, timeout) {
    return new Promise(function (resolve) {
        var cancel = timeout && setTimeout(resolve, timeout);
        var unsub = subscribe(store, selector, function (props) {
            var result = condition(props);
            if (result) {
                unsub();
                cancel && clearTimeout(cancel);
                resolve(result);
            }
        });
    });
}
exports.awaitState = awaitState;
//# sourceMappingURL=helpers.js.map