import { Middleware, Store } from 'redux';
import * as actions from './store/actions';
import { ConfigNullableType, StateType } from './types';
export default class Server {
    store: Store;
    actions: typeof actions;
    express: any;
    socket: any;
    io: any;
    ws: any;
    constructor(config?: ConfigNullableType, middleware?: Middleware | Array<Middleware>);
    start(): Promise<any>;
    flush(force?: boolean): Promise<void>;
    stop(force?: boolean): Promise<void>;
    getStore: () => Store;
    getState: () => StateType;
    subscribe: (selector: Function, callback: Function) => Function;
    awaitState: (selector: Function, condition: Function, timeout?: number | undefined) => Promise<any>;
    health: () => number;
}
