"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_1 = require("redux");
var redux_thunk_1 = __importDefault(require("redux-thunk"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var path_1 = __importDefault(require("path"));
var stoppable_1 = __importDefault(require("stoppable"));
var express_1 = __importDefault(require("express"));
var serve_index_1 = __importDefault(require("serve-index"));
var guid_1 = __importDefault(require("guid"));
var portfinder_1 = __importDefault(require("portfinder"));
var is_port_available_1 = __importDefault(require("is-port-available"));
var stringify_object_extract_functions_1 = __importDefault(require("stringify-object-extract-functions"));
var fix_path_1 = __importDefault(require("fix-path"));
var helpers_1 = require("./helpers");
var actions = __importStar(require("./store/actions"));
var Server = /** @class */ (function () {
    function Server(config, middleware) {
        var _this = this;
        if (middleware === void 0) { middleware = []; }
        this.getStore = function () { return _this.store; };
        this.getState = function () { return _this.store.getState(); };
        this.subscribe = function (selector, callback) { return helpers_1.subscribe(_this.store, selector, callback); };
        this.awaitState = function (selector, condition, timeout) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, helpers_1.awaitState(this.store, selector, condition, timeout)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        }); }); };
        this.health = function () { return 200; };
        try {
            // workaround for: https://github.com/electron/electron/issues/7688
            fix_path_1.default();
            // Create redux store
            this.store = redux_1.createStore(redux_1.combineReducers({
                config: require('./store/reducers/config').default,
                users: require('./store/reducers/users').default,
                workers: require('./store/reducers/workers').default,
                tasks: require('./store/reducers/tasks').default,
                collections: require('./store/reducers/collections').default,
                globals: require('./store/reducers/globals').default,
            }), redux_1.applyMiddleware.apply(void 0, __spreadArrays([redux_thunk_1.default.withExtraArgument(this)], (Array.isArray(middleware) ? middleware : [middleware]))));
            // 1. Bind actions and start observing the store
            this.actions = redux_1.bindActionCreators(actions, this.store.dispatch);
            // 2. Watch task queue ...
            this.subscribe(function (state) { return ({ tasks: state.tasks, workers: state.workers }); }, this.actions.handleTasks);
            // 3. Override default server config
            if (config)
                this.actions.updateConfig(config);
            // 4. Check and create folders
            var output = this.getState().config.output;
            var statepath = path_1.default.join(output, '/states');
            if (fs_extra_1.default.existsSync(statepath))
                fs_extra_1.default.removeSync(statepath);
            fs_extra_1.default.mkdirSync(statepath);
            var logpath_1 = path_1.default.join(output, '/LogFiles');
            !fs_extra_1.default.existsSync(logpath_1) && fs_extra_1.default.mkdirSync(logpath_1);
            // Delete logs older than 5 days
            fs_extra_1.default.readdirSync(logpath_1)
                .map(function (name) { return ({
                name: name,
                time: fs_extra_1.default.statSync(path_1.default.join(logpath_1, name)).mtime.getTime() * 1000 * 60 * 60 * 24,
            }); })
                .filter(function (a) { return a.time > _this.getState().config.logExpirationDays; })
                .forEach(function (a) { return fs_extra_1.default.unlinkSync(path_1.default.join(logpath_1, a.name)); });
        }
        catch (error) {
            console.error(error);
        }
    }
    Server.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, protocol, serverOptions, output, privatePort, publicPort, ip, instances, restTimeout_1, pingTimeout, pingInterval, _b, logPath, promises, error_1;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 7, , 8]);
                        _a = this.getState().config, protocol = _a.protocol, serverOptions = _a.serverOptions, output = _a.output, privatePort = _a.privatePort, publicPort = _a.publicPort, ip = _a.ip, instances = _a.instances, restTimeout_1 = _a.restTimeout, pingTimeout = _a.pingTimeout, pingInterval = _a.pingInterval;
                        this.actions.info('initializing ...');
                        this.actions.cleanup();
                        _b = !privatePort;
                        if (_b) return [3 /*break*/, 2];
                        return [4 /*yield*/, is_port_available_1.default(privatePort)];
                    case 1:
                        _b = (_c.sent()) === false;
                        _c.label = 2;
                    case 2:
                        if (!_b) return [3 /*break*/, 4];
                        // @ts-ignore
                        portfinder_1.default.basePort = 9000 + parseInt(Math.random() * 1000);
                        return [4 /*yield*/, portfinder_1.default.getPortPromise()];
                    case 3:
                        privatePort = _c.sent();
                        this.actions.updateConfig({ privatePort: privatePort });
                        _c.label = 4;
                    case 4:
                        // Stage 2: prepare sockets
                        this.express = express_1.default();
                        this.express.use(require('compression')());
                        this.express.use(require('cors')({ credentials: true, origin: true }));
                        this.express.use(express_1.default.json({ limit: '10mb' }));
                        this.express.use(express_1.default.urlencoded({ limit: '10mb', extended: true }));
                        this.socket = stoppable_1.default(protocol === 'https'
                            ? require('https').createServer(serverOptions, this.express)
                            : require('http').createServer(this.express));
                        this.socket.timeout = 0;
                        this.socket.keepAliveTimeout = 0;
                        this.socket.maxConnections = 100000;
                        this.io = require('socket.io')(this.socket, {
                            serveClient: false,
                            pingTimeout: pingTimeout,
                            pingInterval: pingInterval,
                        });
                        this.socket.listen(publicPort, ip);
                        this.socket.on('error', function (err) { return console.log(err); });
                        // Stage 3: listen ...
                        this.actions.info("accept " + protocol + "://" + ip + ":" + publicPort + "/", { owner: 'io' });
                        this.io.on('connection', this.actions.handleUser);
                        // REST health endpoint, used for load balancer probing
                        this.actions.info("accept " + protocol + "://" + ip + ":" + publicPort + "/health", { owner: protocol });
                        this.express.get('/health', function (req, res) { return res.sendStatus(_this.health()); });
                        // REST Status endpoint
                        this.actions.info("accept " + protocol + "://" + ip + ":" + publicPort + "/status", { owner: protocol });
                        this.express.get('/status', function (req, res) {
                            var currentState = _this.getState();
                            var state = __assign(__assign({}, currentState), { config: __assign({}, currentState.config) });
                            delete state.config.executable;
                            delete state.config.output;
                            delete state.config.exec;
                            delete state.config.execArgs;
                            res.type('text/plain').send(stringify_object_extract_functions_1.default(state, { indent: '  ', inlineCharacterLimit: 256 }));
                        });
                        logPath = this.getState().config.output + '/LogFiles';
                        this.actions.info("accept " + protocol + "://" + ip + ":" + publicPort + "/log", { owner: protocol });
                        this.express.use('/log', express_1.default.static(logPath), serve_index_1.default(logPath, { icons: true, view: 'details' }));
                        // REST Login
                        this.actions.info("accept " + protocol + "://" + ip + ":" + publicPort + "/login", { owner: protocol });
                        this.express.get('/login', function (req, res) {
                            req.socket.setTimeout(restTimeout_1);
                            var id = guid_1.default.raw();
                            _this.actions.addUser(id);
                            res.json({ op: 'system', status: 'permitted', id: id });
                        });
                        // REST Logout
                        this.actions.info("accept " + protocol + "://" + ip + ":" + publicPort + "/logout/:id", { owner: protocol });
                        this.express.get('/logout/:id', function (req, res) {
                            req.socket.setTimeout(restTimeout_1);
                            _this.actions.removeUser(req.params.id);
                            res.type('text/plain').send("disconnected");
                        });
                        // REST POST Execute
                        this.actions.info("accept " + protocol + "://" + ip + ":" + publicPort + "/execute/:id", { owner: protocol });
                        this.express.post('/execute/:id', function (req, res) { return __awaiter(_this, void 0, void 0, function () {
                            var context, reason_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        req.socket.setKeepAlive(true);
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4 /*yield*/, this.actions.createTask(req.body, req.params.id)];
                                    case 2:
                                        context = _a.sent();
                                        res.json(context.results);
                                        return [3 /*break*/, 4];
                                    case 3:
                                        reason_1 = _a.sent();
                                        this.actions.error(reason_1);
                                        res.status(500).json({ message: reason_1.message });
                                        return [3 /*break*/, 4];
                                    case 4: return [2 /*return*/];
                                }
                            });
                        }); });
                        // Internal WebSocket queue (used only by workers)...
                        this.actions.info("accept ws://" + ip + ":" + privatePort + "/", { owner: 'ws' });
                        this.ws = new (require('ws')).Server({ port: privatePort });
                        this.ws.on('connection', this.actions.handleWorker);
                        this.ws.on('error', this.actions.error);
                        // Stage 4: signal the running state
                        this.store.dispatch(actions.updateGlobals({ running: true }));
                        // Stage 5: spawn local workers
                        this.actions.info(new Array(1).fill('-').join(''));
                        if (!(instances > 0)) return [3 /*break*/, 6];
                        promises = new Array(instances).fill(null).map(function () { return _this.actions.spawnWorker(); });
                        return [4 /*yield*/, Promise.all(promises)];
                    case 5:
                        _c.sent();
                        _c.label = 6;
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        error_1 = _c.sent();
                        this.actions.error(error_1);
                        return [2 /*return*/, error_1];
                    case 8: return [2 /*return*/, this];
                }
            });
        });
    };
    Server.prototype.flush = function (force) {
        if (force === void 0) { force = false; }
        return __awaiter(this, void 0, void 0, function () {
            var error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        this.actions.info('flushing workers ...');
                        return [4 /*yield*/, this.stop(force)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.start()];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_2 = _a.sent();
                        console.error(error_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Server.prototype.stop = function (force) {
        if (force === void 0) { force = false; }
        return __awaiter(this, void 0, void 0, function () {
            var error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        this.actions.info('shutting down ...');
                        this.actions.updateGlobals({ running: false });
                        return [4 /*yield*/, this.actions.cleanup(force)];
                    case 1:
                        _a.sent();
                        this.io && this.io.close();
                        this.ws && this.ws.close();
                        this.socket && this.socket.stop();
                        this.socket = this.io = this.ws = this.express = undefined;
                        return [3 /*break*/, 3];
                    case 2:
                        error_3 = _a.sent();
                        console.error(error_3);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Server;
}());
exports.default = Server;
//# sourceMappingURL=server.js.map