import { GlobalsNullableType, ConfigNullableType, LogNullableType, StateType } from '../../types';
export declare function cleanup(force?: boolean): (dispatch: any, getState: () => StateType) => Promise<void>;
export declare function updateGlobals(props: GlobalsNullableType): {
    running?: boolean | undefined;
    cpu?: number | undefined;
    spawned?: number | undefined;
    tasks?: number | undefined;
    log?: any[] | undefined;
    type: string;
};
export declare function updateConfig(props: ConfigNullableType): {
    executable?: string | undefined;
    configurationData?: string | undefined;
    output?: string | undefined;
    protocol?: string | undefined;
    serverOptions?: any;
    ip?: string | undefined;
    privatePort?: number | undefined;
    publicPort?: number | undefined;
    binary?: boolean | undefined;
    multipart?: boolean | undefined;
    compression?: boolean | undefined;
    sendTreePatches?: boolean | undefined;
    stdout?: boolean | undefined;
    secureApi?: boolean | undefined;
    instances?: number | undefined;
    debug?: boolean | undefined;
    showConsole?: boolean | undefined;
    stateDebounce?: number | undefined;
    maxStates?: number | undefined;
    workerTimeout?: number | undefined;
    restTimeout?: number | undefined;
    pingTimeout?: number | undefined;
    pingInterval?: number | undefined;
    collectResultsOnly?: boolean | undefined;
    enableTaskSalvaging?: boolean | undefined;
    logExpirationDays?: number | undefined;
    exec?: string | undefined;
    execArgs?: string[] | undefined;
    type: string;
};
export declare function error(reason: any, args?: LogNullableType): {
    type: string;
    level: string;
    text: any;
    args: {
        owner: string;
        worker?: string | void | undefined;
        user?: string | void | undefined;
        task?: string | void | undefined;
        duration?: number | undefined;
    };
};
export declare function info(text: any, args?: LogNullableType): {
    type: string;
    level: string;
    text: any;
    args: {
        owner: string;
        worker?: string | void | undefined;
        user?: string | void | undefined;
        task?: string | void | undefined;
        duration?: number | undefined;
    };
};
export declare function log(text: any, args?: LogNullableType): {
    type: string;
    level: string;
    text: any;
    args: {
        owner: string;
        worker?: string | void | undefined;
        user?: string | void | undefined;
        task?: string | void | undefined;
        duration?: number | undefined;
    };
};
export declare function warn(text: any, args?: LogNullableType): {
    type: string;
    level: string;
    text: any;
    args: {
        owner: string;
        worker?: string | void | undefined;
        user?: string | void | undefined;
        task?: string | void | undefined;
        duration?: number | undefined;
    };
};
export declare function debug(text: any, args?: LogNullableType): {
    type: string;
    level: string;
    text: any;
    args: {
        owner: string;
        worker?: string | void | undefined;
        user?: string | void | undefined;
        task?: string | void | undefined;
        duration?: number | undefined;
    };
};
