"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleTasks = exports.updateTask = exports.removeTask = exports.pushTask = exports.createTask = void 0;
var lodash_1 = __importDefault(require("lodash"));
var guid_1 = __importDefault(require("guid"));
var util_1 = __importDefault(require("util"));
var types = __importStar(require("../types"));
var workerActions = __importStar(require("./worker"));
var userActions = __importStar(require("./user"));
var globalActions = __importStar(require("./global"));
/**
 * Creates and pushes a task, this will trigger unoccupied workers to execute it.
 * The result will be a promise that resolves to the finished task
 *
 * @param {any | Array<any>} commands
 * @param {IdType | void} user
 * @param {IdType = guid.raw()} task
 * @param {IdType} worker
 */
function createTask(commands, user, task, worker) {
    if (task === void 0) { task = guid_1.default.raw(); }
    return function (dispatch, getState) {
        var _a = getState(), users = _a.users, workers = _a.workers;
        if (user !== undefined && !users[user]) {
            dispatch(globalActions.warn("user doesn't exist!", { user: user, worker: worker, task: task }));
            return Promise.reject("User " + user + " doesn't exist");
        }
        var callbacks = [], promise = new Promise(function (res, rej) { return (callbacks = [res, rej]); });
        dispatch(globalActions.info("accepted " + util_1.default.inspect(commands, { depth: null }).slice(0, 256), {
            owner: 'task',
            user: user,
            task: task,
            worker: worker,
        }));
        commands = Array.isArray(commands) ? commands : [commands];
        if (user)
            dispatch(userActions.updateUser(user));
        dispatch(pushTask(task, user, commands, promise, callbacks[0], callbacks[1], worker));
        return promise;
    };
}
exports.createTask = createTask;
/**
 * Pushes a global or worker-bound task
 *
 * @param {IdType} task
 * @param {IdType | void} user
 * @param {Array<string>} commands
 * @param {Promise<any>} promise
 * @param {any} resolve
 * @param {any} reject
 * @param {string | void} worker
 * @param {number} timestamp
 */
function pushTask(task, user, commands, promise, resolve, reject, worker, timestamp) {
    return { type: types.pushTask, task: task, user: user, commands: commands, promise: promise, resolve: resolve, reject: reject, worker: worker, timestamp: timestamp };
}
exports.pushTask = pushTask;
/**
 * Removes a task, this is used by the worker once it has resolved a task
 *
 * @param {IdType} task
 * @param {IdType} worker
 */
function removeTask(task, worker) {
    return { type: types.removeTask, worker: worker, task: task };
}
exports.removeTask = removeTask;
/**
 * Update task
 *
 * @param {IdType} task
 * @param {IdType | void} worker
 * @param {TaskNullableType} props
 */
function updateTask(task, worker, props) {
    return __assign({ type: types.updateTask, worker: worker, task: task }, props);
}
exports.updateTask = updateTask;
/**
 * Observe tasks and workers, every reaction triggers the observer to look for unfulfileld
 * tasks that should then be applied to workers signaling their availability by the occupid flag
 */
function handleTasks() {
    var _this = this;
    return function (dispatch, getState) { return __awaiter(_this, void 0, void 0, function () {
        var state_1, first_1, worker, _i, _a, candidate, id, socket, tasks, tasks_2, _b, tasks_1, task, error_1;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 14, , 15]);
                    state_1 = getState();
                    if (!state_1.tasks.length) return [3 /*break*/, 13];
                    first_1 = state_1.tasks[0];
                    worker = void 0;
                    for (_i = 0, _a = Object.keys(state_1.workers).map(function (key) { return state_1.workers[key]; }); _i < _a.length; _i++) {
                        candidate = _a[_i];
                        // Worker should be alive
                        if (!candidate.alive)
                            continue;
                        else if (candidate.lastUser === first_1.user) {
                            // We prefer workers that worked for the same user previously
                            worker = candidate;
                            break;
                        }
                        else if (candidate.occupied)
                            // It shouldn't be occupied
                            continue;
                        else if (!worker || worker.timestamp < candidate.timestamp)
                            // Otherwise we pick a worker with the oldest timestamp
                            worker = candidate;
                    }
                    if (!worker) return [3 /*break*/, 13];
                    id = worker.id, socket = worker.socket;
                    tasks = state_1.tasks.filter(function (task) { return task.user === first_1.user; });
                    // Add tasks to occupied worker
                    if (worker.occupied) {
                        dispatch(globalActions.info("adds " + tasks.length + " tasks", { owner: 'worker', worker: id, user: first_1.user }));
                        return [2 /*return*/, dispatch({ type: types.claimWorker, worker: id, user: first_1.user, tasks: tasks })];
                    }
                    // Claim worker, add tasks to its own collection
                    dispatch(workerActions.claimWorker(id, first_1.user, tasks));
                    if (!(worker.lastUser !== first_1.user)) return [3 /*break*/, 5];
                    if (!(worker.lastUser && getState().users[worker.lastUser])) return [3 /*break*/, 2];
                    return [4 /*yield*/, dispatch(userActions.storeState(worker.lastUser, id))
                        // Clear worker
                    ];
                case 1:
                    _c.sent();
                    _c.label = 2;
                case 2: 
                // Clear worker
                return [4 /*yield*/, dispatch(workerActions.clear(id))
                    // Load users last state, if present
                ];
                case 3:
                    // Clear worker
                    _c.sent();
                    // Load users last state, if present
                    return [4 /*yield*/, dispatch(userActions.loadState(first_1.user, id))];
                case 4:
                    // Load users last state, if present
                    _c.sent();
                    _c.label = 5;
                case 5:
                    if (!getState().workers[id]) return [3 /*break*/, 12];
                    tasks_2 = lodash_1.default.sortBy(getState().workers[id].tasks, ['timestamp']);
                    if (!(tasks_2 && tasks_2.length > 0)) return [3 /*break*/, 10];
                    _b = 0, tasks_1 = tasks_2;
                    _c.label = 6;
                case 6:
                    if (!(_b < tasks_1.length)) return [3 /*break*/, 9];
                    task = tasks_1[_b];
                    return [4 /*yield*/, dispatch(workerActions.execute(id, task))];
                case 7:
                    _c.sent();
                    _c.label = 8;
                case 8:
                    _b++;
                    return [3 /*break*/, 6];
                case 9: return [3 /*break*/, 11];
                case 10: return [3 /*break*/, 12];
                case 11: return [3 /*break*/, 5];
                case 12:
                    dispatch(workerActions.releaseWorker(id));
                    _c.label = 13;
                case 13: return [3 /*break*/, 15];
                case 14:
                    error_1 = _c.sent();
                    dispatch(globalActions.error(error_1));
                    return [3 /*break*/, 15];
                case 15: return [2 /*return*/];
            }
        });
    }); };
}
exports.handleTasks = handleTasks;
//# sourceMappingURL=task.js.map