"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleUser = exports.undoRedo = exports.clearStates = exports.loadState = exports.storeState = exports.updateUser = exports.removeUser = exports.addUser = exports.emitFrame = exports.emit = void 0;
var lodash_1 = __importDefault(require("lodash"));
var path_1 = __importDefault(require("path"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var types = __importStar(require("../types"));
var workerActions = __importStar(require("./worker"));
var taskActions = __importStar(require("./task"));
var globalActions = __importStar(require("./global"));
var defaults_1 = __importDefault(require("../../defaults"));
/**
 * Sends data via SocketIO wrapped around a Promise which resolves once the client acknowledges
 *
 * @param {*} socket
 * @param {*} data
 */
var emitAsync = function (socket, data) {
    return new Promise(function (resolve, reject) {
        try {
            socket.emit(data instanceof Buffer ? 'binary' : 'json', data, resolve);
        }
        catch (error) {
            reject(error);
        }
    });
};
/**
 * Emits data back to the user via socket or collects it internally under task.results. Emit is queued.
 *
 * @param {IdType} user
 * @param {Object | Array<Object>} data
 * @param {IdType} task
 * @param {IdType | void} worker
 * @param {boolean = false} wrap - Wrap the message into Begin- & EndFrame pairs
 */
function emit(user, data, task, worker, wrap) {
    var _this = this;
    if (wrap === void 0) { wrap = false; }
    return function (dispatch, getState) {
        data = Array.isArray(data) ? data : [data];
        var _a = getState(), users = _a.users, config = _a.config;
        var userObj = users[user];
        if (userObj && userObj.socket) {
            // If the user is bound to a socket, respond there ...
            var queue = userObj.queue
                .then(function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!wrap) return [3 /*break*/, 2];
                            return [4 /*yield*/, emitAsync(userObj.socket, { command: 'Result', from: 'BeginFrame', result: '', transactionID: task })
                                // 2. Send contents
                            ];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: 
                        // 2. Send contents
                        return [4 /*yield*/, Promise.all(data.map(function (item) { return emitAsync(userObj.socket, item); }))
                            // 3. Send EndFrame to signal end of message
                        ];
                        case 3:
                            // 2. Send contents
                            _a.sent();
                            // 3. Send EndFrame to signal end of message
                            if (wrap)
                                emitAsync(userObj.socket, { command: 'Result', from: 'EndFrame', result: '', transactionID: task });
                            return [2 /*return*/];
                    }
                });
            }); })
                .catch(function (error) { return dispatch(globalActions.error(error, { owner: 'user', user: user, task: task })); });
            // Update the users internal promise-queue
            dispatch(updateUser(user, { queue: queue }));
            return queue;
        }
        else {
            data.forEach(function (item) {
                // If the user doesn't have a socket it should collect results in the task given
                if (!userObj || config.collectResultsOnly) {
                    // Collect data only, this is for internal commands (user=undefined) or programmatic tasks
                    item.result &&
                        dispatch(taskActions.updateTask(task, worker, { results: [item.result], streamData: item.streamData }));
                }
                else {
                    // Otherwise everything is collected, this is for rest-endpoints for instance ...
                    dispatch(taskActions.updateTask(task, worker, { results: [item] }));
                }
            });
        }
    };
}
exports.emit = emit;
/**
 * Emits Begin- & End-framed data back to the user via socket or collects it internally under task.results. Emit is queued.
 *
 * @param {IdType} user
 * @param {Object | Array<Object>} data
 * @param {IdType} task
 * @param {IdType | void} worker
 */
function emitFrame(user, data, task, worker) {
    return emit(user, data, task, worker, true);
}
exports.emitFrame = emitFrame;
/**
 * Adds new user
 *
 * @param {IdType} user
 * @param {*} socket
 */
function addUser(user, socket) {
    return function (dispatch, getState) {
        //dispatch(globalActions.info(`accepted ${user}`, { owner: 'user', user }))
        var output = getState().config.output;
        var folder = path_1.default.join(output, 'states', "" + user);
        if (fs_extra_1.default.existsSync(folder))
            fs_extra_1.default.removeSync(folder);
        fs_extra_1.default.mkdirSync(folder);
        dispatch({ type: types.addUser, user: user, socket: socket, folder: folder });
    };
}
exports.addUser = addUser;
/**
 * Removes existing user
 *
 * @param {IdType} user
 */
function removeUser(user) {
    return function (dispatch, getState) {
        var _a = getState(), users = _a.users, config = _a.config;
        var userObj = users[user];
        if (userObj) {
            dispatch(globalActions.info("terminating " + user, { owner: 'user', user: user }));
            dispatch({ type: types.removeUser, user: user });
            setTimeout(function () {
                try {
                    if (fs_extra_1.default.existsSync(userObj.folder))
                        fs_extra_1.default.removeSync(userObj.folder);
                }
                catch (error) {
                    dispatch(globalActions.error("remove state folder throws an error: " + error, { owner: 'user', user: user }));
                }
            }, config.stateDebounce + 5000);
        }
        // Remove any trace or leftover the user has left
        getState().collections.workers.forEach(function (w) { return getState().workers[w].lastUser === user && dispatch(workerActions.updateWorker(w, { lastUser: undefined })); });
    };
}
exports.removeUser = removeUser;
/**
 * Updates existing user
 *
 * @param {IdType} user
 * @param {UserNullableType} updates
 */
function updateUser(user, updates) {
    return { type: types.updateUser, user: user, updates: updates };
}
exports.updateUser = updateUser;
/**
 * Stores user state in its local state-folder
 *
 * @param {IdType} user
 * @param {IdType} worker
 */
function storeState(user, worker, task) {
    var _this = this;
    return function (dispatch, getState) { return __awaiter(_this, void 0, void 0, function () {
        var _a, users, config, userObj, response, systemFile, command, stateFiles;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = getState(), users = _a.users, config = _a.config;
                    userObj = users[user];
                    if (!(userObj && userObj.actions > 0)) return [3 /*break*/, 5];
                    // Delete newer states, this means the user undid something and started to work on that state
                    try {
                        if (userObj.systemFile)
                            userObj.stateFiles
                                .filter(function (state) { return parseInt(state) > parseInt(userObj.systemFile); })
                                .forEach(function (state) { return fs_extra_1.default.unlinkSync(path_1.default.join(userObj.folder, state)); });
                    }
                    catch (error) {
                        dispatch(globalActions.error(error, { owner: 'user', user: user, worker: worker, task: task }));
                    }
                    response = void 0, systemFile = defaults_1.default.now() + ".state", command = { command: 'StoreState', path: path_1.default.join(userObj.folder, systemFile) };
                    if (!worker) return [3 /*break*/, 2];
                    return [4 /*yield*/, dispatch(workerActions.execute(worker, [command]))];
                case 1:
                    response = _b.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, dispatch(taskActions.createTask(command, user, task))
                    // List and sort all states
                ];
                case 3:
                    response = _b.sent();
                    _b.label = 4;
                case 4:
                    stateFiles = fs_extra_1.default.readdirSync(userObj.folder).sort(function (a, b) { return parseInt(a) > parseInt(b); });
                    // Remove trailing state, if present
                    try {
                        if (stateFiles.length > config.maxStates)
                            fs_extra_1.default.unlinkSync(path_1.default.join(userObj.folder, stateFiles.shift()));
                    }
                    catch (error) {
                        dispatch(globalActions.error(error, { owner: 'user', user: user, worker: worker, task: task }));
                    }
                    // Update system-state file and reset actions to zero
                    dispatch(updateUser(user, { systemFile: systemFile, stateFiles: stateFiles, actions: 0 }));
                    // Notify user since states have changed
                    userObj.socket && userObj.socket.emit('undo', { count: stateFiles.length, current: stateFiles.length - 1 });
                    return [2 /*return*/, response];
                case 5: return [2 /*return*/];
            }
        });
    }); };
}
exports.storeState = storeState;
/**
 * loads the most recent user state from its local user state-folder.
 *
 * @param {IdType} user
 * @param {IdType} worker
 */
function loadState(user, worker, task, name) {
    var _this = this;
    return function (dispatch, getState) { return __awaiter(_this, void 0, void 0, function () {
        var userObj, systemFile, folder, stateFiles, socket, statePath, response, command;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    userObj = getState().users[user];
                    if (!userObj) return [3 /*break*/, 5];
                    systemFile = userObj.systemFile, folder = userObj.folder, stateFiles = userObj.stateFiles, socket = userObj.socket;
                    statePath = (name || systemFile) && path_1.default.join(folder, name || systemFile);
                    if (!fs_extra_1.default.existsSync(statePath)) return [3 /*break*/, 5];
                    response = void 0, command = {
                        command: 'LoadState',
                        path: statePath,
                        recalc: false,
                        updateGraphics: !!name,
                        isUndoOrRedo: !!name,
                    };
                    if (!worker) return [3 /*break*/, 2];
                    return [4 /*yield*/, dispatch(workerActions.execute(worker, [command]))];
                case 1:
                    response = _a.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, dispatch(taskActions.createTask(command, user, task))];
                case 3:
                    response = _a.sent();
                    _a.label = 4;
                case 4:
                    if (name) {
                        // When an explicit name was given (undo/redo), update systemFile and notify user
                        dispatch(updateUser(user, { systemFile: name }));
                        socket && socket.emit('undo', { count: stateFiles.length, current: stateFiles.indexOf(name) });
                    }
                    return [2 /*return*/, response];
                case 5: return [2 /*return*/];
            }
        });
    }); };
}
exports.loadState = loadState;
/**
 * Clear all states.
 *
 * @param {IdType} user
 */
function clearStates(user) {
    var _this = this;
    return function (dispatch, getState) { return __awaiter(_this, void 0, void 0, function () {
        var userObj;
        return __generator(this, function (_a) {
            userObj = getState().users[user];
            if (userObj) {
                try {
                    userObj.socket && userObj.socket.emit('undo', { count: 0, current: 0 });
                    userObj.stateFiles.forEach(function (state) { return userObj.systemFile !== state && fs_extra_1.default.unlinkSync(path_1.default.join(userObj.folder, state)); });
                }
                catch (error) {
                    //dispatch(globalActions.error(error, { owner: 'user', user }))
                    dispatch(globalActions.error(error.stack + " " + JSON.stringify(userObj), { owner: 'user', user: user }));
                }
                finally {
                    dispatch(updateUser(user, { stateFiles: [] }));
                }
            }
            return [2 /*return*/];
        });
    }); };
}
exports.clearStates = clearStates;
/**
 * Either call loadState or cause a simple ping in order to prevent choking
 * the client which might be waiting for a response.
 *
 * @param {IdType} user
 * @param {'undo' | 'redo'} type
 */
function undoRedo(user, type, task) {
    var _this = this;
    return function (dispatch, getState) { return __awaiter(_this, void 0, void 0, function () {
        var userObj, stateFiles, systemFile, id, state;
        return __generator(this, function (_a) {
            userObj = getState().users[user];
            if (userObj) {
                stateFiles = userObj.stateFiles, systemFile = userObj.systemFile, id = userObj.id;
                state = stateFiles[stateFiles.indexOf(systemFile) + (type === 'undo' ? -1 : 1)];
                if (state)
                    dispatch(loadState(id, undefined, task, state));
                else
                    dispatch(taskActions.createTask({}, id, task));
            }
            return [2 /*return*/];
        });
    }); };
}
exports.undoRedo = undoRedo;
/**
 * Deals with a users socket and dispatches actions
 *
 * @param {*} socket
 */
function handleUser(socket) {
    var _this = this;
    return function (dispatch, getState) { return __awaiter(_this, void 0, void 0, function () {
        var debouncedStoreState, id;
        var _this = this;
        return __generator(this, function (_a) {
            debouncedStoreState = lodash_1.default.debounce(function (id) { return getState().globals.running && getState().users[id] && dispatch(storeState(id)); }, getState().config.stateDebounce);
            socket.on('error', function (error) { return dispatch(globalActions.error(error)); });
            socket.on('disconnect', function () { return dispatch(removeUser(id)); });
            socket.once('init', function (options) {
                id = socket.id;
                dispatch(addUser(id, socket));
                socket.emit('permission', { id: id, version: '8.x.x' });
                socket.on('send', function (contextId, command) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        dispatch(taskActions.createTask(command, id, contextId));
                        debouncedStoreState(id);
                        return [2 /*return*/];
                    });
                }); });
                socket.on('undo', function (task) { return dispatch(undoRedo(id, 'undo', task)); });
                socket.on('redo', function (task) { return dispatch(undoRedo(id, 'redo', task)); });
            });
            return [2 /*return*/];
        });
    }); };
}
exports.handleUser = handleUser;
//# sourceMappingURL=user.js.map