"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.spawnWorker = exports.handleWorker = exports.emitWorkerTask = exports.releaseWorker = exports.claimWorker = exports.resolveWorkerTask = exports.clear = exports.execute = exports.removeWorker = exports.updateWorker = exports.addWorker = void 0;
var guid_1 = __importDefault(require("guid"));
var util_1 = __importDefault(require("util"));
var delay_1 = __importDefault(require("delay"));
var child_process_1 = require("child_process");
var types = __importStar(require("../types"));
var userActions = __importStar(require("./user"));
var taskActions = __importStar(require("./task"));
var globalActions = __importStar(require("./global"));
var helpers_1 = require("../../helpers");
var defaults_1 = __importDefault(require("../../defaults"));
/**
 * Adds new worker
 *
 * @param {IdType} worker
 * @param {*} socket
 */
function addWorker(worker, socket) {
    return function (dispatch) {
        dispatch(globalActions.info("accepted", { owner: 'worker', worker: worker }));
        dispatch({ type: types.addWorker, worker: worker, socket: socket });
    };
}
exports.addWorker = addWorker;
/**
 * Updates existig worker
 *
 * @param {IdType} worker
 * @param {WorkerNullableType} updates
 */
function updateWorker(worker, updates) {
    return { type: types.updateWorker, worker: worker, updates: updates };
}
exports.updateWorker = updateWorker;
/**
 * Removes existing worker. Force==true will kill the worker right away, then collect open tasks in order
 * to push them to the global queue again so another unoccupied worker may pick them up. If force==false
 * then it will wait until the worker has resolved its open tasks first, then kill it.
 *
 * @param {IdType} worker
 * @param {boolean = false} force
 */
function removeWorker(worker, force) {
    var _this = this;
    if (force === void 0) { force = false; }
    return function (dispatch, getState) { return __awaiter(_this, void 0, void 0, function () {
        var s, w;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    s = getState();
                    w = s.workers[worker];
                    if (!w) return [3 /*break*/, 4];
                    dispatch(updateWorker(worker, { alive: false }));
                    if (!force) return [3 /*break*/, 1];
                    if (s.config.enableTaskSalvaging) {
                        // Transfer remaining tasks over to the global collection so they can be processed again
                        w.tasks.forEach(function (t) {
                            if (t.user) {
                                var args = { owner: 'worker', worker: worker, user: t.user || w.lastUser, task: t.id };
                                dispatch(globalActions.warn("salvaging " + util_1.default.inspect(t.commands, { depth: null }).replace(/\s+/g, ' '), args));
                                dispatch(taskActions.pushTask(t.id, t.user, t.commands, t.promise, t.resolve, t.reject, undefined, t.timestamp));
                            }
                        });
                    }
                    w.resolve && w.resolve();
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, w.sequence];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    dispatch({ type: types.removeWorker, worker: worker });
                    w.process && w.process.kill();
                    w.socket && w.socket.close();
                    dispatch(globalActions.info("terminated " + worker + " " + (force ? 'hard' : 'soft'), { owner: 'worker', worker: worker }));
                    _a.label = 4;
                case 4: return [2 /*return*/];
            }
        });
    }); };
}
exports.removeWorker = removeWorker;
/**
 * Sends a task or a series of commands to a worker
 *
 * @param {IdType} worker
 * @param {*} payload
 */
function execute(worker, payload) {
    return function (dispatch, getState) {
        var _a = getState(), workers = _a.workers, users = _a.users;
        var workerObj = workers[worker];
        if (workerObj) {
            var isTask = !Array.isArray(payload);
            var transactionID_1 = isTask ? payload.id : guid_1.default.raw();
            var user_1 = isTask ? payload.user : undefined;
            var promise = isTask ? payload.promise : dispatch(taskActions.createTask(payload, user_1, transactionID_1, worker));
            var commands = isTask ? payload.commands : payload;
            // Count user actions
            if (user_1 && users[user_1])
                dispatch(userActions.updateUser(user_1, { actions: users[user_1].actions + 1 }));
            // Wrap payload into BeginFrame/EndFrame pairs and send to worker
            workerObj.socket.send(JSON.stringify({ command: 'BeginFrame', transactionID: transactionID_1 }));
            commands.forEach(function (command) {
                var slice = util_1.default.inspect(command, { depth: null });
                if (slice.length > 256)
                    slice = slice.slice(0, 256) + ' ...';
                dispatch(globalActions.log("  sends " + slice.replace(/\s+/g, ' '), {
                    owner: 'worker',
                    worker: worker,
                    user: user_1,
                    task: transactionID_1,
                }));
                workerObj.socket.send(JSON.stringify(command));
            });
            workerObj.socket.send(JSON.stringify({ command: 'EndFrame', transactionID: transactionID_1 }));
            return promise;
        }
        return Promise.reject('worker not found');
    };
}
exports.execute = execute;
/**
 * Clears worker
 *
 * @param {IdType} worker
 */
function clear(worker) {
    var _this = this;
    return function (dispatch, getState) { return __awaiter(_this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    if (!getState().workers[worker]) return [3 /*break*/, 2];
                    dispatch(globalActions.info("clearing", { owner: 'worker', worker: worker }));
                    return [4 /*yield*/, dispatch(execute(worker, [{ command: 'Clear' }]))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    dispatch(globalActions.error(error_1, { owner: 'worker', worker: worker }));
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); };
}
exports.clear = clear;
/**
 * This marks a workers task as completed and resolves & removes it
 *
 * @param {IdType} worker
 * @param {IdType} taskId
 */
function resolveWorkerTask(worker, taskId) {
    return function (dispatch, getState) {
        var task = getState().workers[worker].tasks.find(function (t) { return t.id === taskId; });
        dispatch(taskActions.removeTask(taskId, worker));
        if (task) {
            task.duration = (defaults_1.default.now() - task.timestamp) / 1000;
            dispatch(globalActions.info("resolved", {
                owner: 'task',
                user: task.user,
                task: taskId,
                worker: worker,
                duration: task.duration,
            }));
            task.resolve && task.resolve(task);
        }
    };
}
exports.resolveWorkerTask = resolveWorkerTask;
/**
 * Marks a worker as occupied, removes a group of tasks and returns a resolver that should be called
 * once all of the tasks have been resolved.
 *
 * @param {IdType} worker
 * @param {IdType} user
 * @param {Array<TaskType>} tasks
 */
function claimWorker(worker, user, tasks) {
    return function (dispatch) {
        dispatch(globalActions.info("claims " + tasks.length + " tasks", { owner: 'worker', worker: worker, user: user }));
        var resolve, sequence = new Promise(function (r) { return (resolve = r); });
        dispatch({ type: types.claimWorker, worker: worker, user: user, tasks: tasks, sequence: sequence, resolve: resolve });
    };
}
exports.claimWorker = claimWorker;
/**
 * Resolves worker and signals it free for the taking
 *
 * @param {IdType} worker
 */
function releaseWorker(worker) {
    return function (dispatch, getState) {
        var workerObj = getState().workers[worker];
        if (workerObj) {
            dispatch(globalActions.info("released", { owner: 'worker', worker: worker }));
            workerObj.resolve && workerObj.resolve();
            dispatch({ type: types.releaseWorker, worker: worker });
        }
    };
}
exports.releaseWorker = releaseWorker;
/**
 * Deals with socket errors
 *
 * @param {IdType} worker
 * @param {Error} workerError
 */
function handleWorkerError(worker, workerError) {
    return function (dispatch, getState) {
        var running = getState().globals.running;
        if (running)
            dispatch(globalActions.error(workerError || new Error("worker closed while running"), { owner: 'worker', worker: worker }));
        dispatch(removeWorker(worker, running));
    };
}
/**
 * Forwards results to receiver, may be a users socket or the tasks result collection
 *
 * @param {IdType} worker
 * @param {IdType} task
 * @param {Object} data
 */
function emitWorkerTask(worker, task, data) {
    return function (dispatch, getState) {
        var _a = getState(), users = _a.users, workers = _a.workers, config = _a.config;
        var isBinary = data instanceof Buffer;
        var t = workers[worker].tasks.find(function (t) { return t.id === task; });
        if (t) {
            var args = { owner: 'worker', worker: worker, user: t.user, task: task, duration: (defaults_1.default.now() - t.timestamp) / 1000 };
            if (!isBinary && data.command === 'ErrorMessage') {
                var errorState = parseInt(data.attributes.errorState);
                switch (errorState //0: no error; 1: warning, 2: error go on; 3: error stop
                ) {
                    case 0:
                        dispatch(globalActions.info(data.attributes.errorMessage, args));
                        break;
                    case 1:
                        dispatch(globalActions.warn(data.attributes.errorMessage, args));
                        break;
                    case 2:
                    case 3:
                    default:
                        dispatch(globalActions.error(data.attributes.errorMessage, args));
                        break;
                }
            }
            if (isBinary) {
                dispatch(globalActions.log("received [binary]", args));
            }
            else if (data.result) {
                var slice = util_1.default.inspect(data.result, { depth: null });
                if (slice.length > 256)
                    slice = slice.slice(0, 256) + ' ...';
                dispatch(globalActions.log("received " + slice.replace(/\s+/g, ' '), args));
            }
            dispatch(userActions.emit(t.user, data, task, worker));
        }
    };
}
exports.emitWorkerTask = emitWorkerTask;
/**
 * Deals with a workers socket and dispatches further actions
 *
 * @param {*} socket
 */
function handleWorker(socket) {
    return function (dispatch, getState) {
        var id;
        var task;
        var user;
        try {
            socket.on('error', function (error) { return dispatch(handleWorkerError(id, error)); });
            socket.on('close', function () { return dispatch(handleWorkerError(id)); });
            socket.on('message', function (data) {
                try {
                    var isBinary = data instanceof Buffer;
                    var _a = getState(), users = _a.users, workers = _a.workers, globals = _a.globals;
                    if (!isBinary) {
                        // Convert data to JSON
                        data = JSON.parse(data);
                        // ClassCAD sends first handshake, which feeds back the id and then the ready state
                        if (data.response === 'Handshake') {
                            id = data.id;
                        }
                        else if (data.response === 'Ready') {
                            dispatch(addWorker(id, socket));
                        }
                        else if (data.from === 'BeginFrame') {
                            // BeginFrame marks the beginning of a sequence of commands and carries a task id
                            task = workers[id].tasks.find(function (task) { return task.id === data.transactionID; });
                            user = task && users[task.id];
                        }
                    }
                    if (task) {
                        // Forward results to the users socket or the tasks result collection
                        dispatch(emitWorkerTask(id, task.id, data));
                        if (!isBinary && data.from === 'EndFrame') {
                            // EndFrame makrs the end of a sequence of commands, resolves a task
                            dispatch(resolveWorkerTask(id, task.id));
                        }
                    }
                }
                catch (error) {
                    dispatch(globalActions.error(error, {
                        owner: 'worker',
                        worker: id,
                        task: task ? task.id : undefined,
                        user: user ? user.id : undefined,
                    }));
                    if (task)
                        task.reject(error);
                }
            });
            // Allow ClassCAD to participate
            var _a = getState().config, configurationData = _a.configurationData, compression = _a.compression, multipart = _a.multipart, sendTreePatches = _a.sendTreePatches, disableGraphics = _a.disableGraphics, enableInvisibleGraphics = _a.enableInvisibleGraphics;
            socket.send(JSON.stringify({
                command: 'configuration',
                configurationData: configurationData,
                compression: compression,
                multipart: multipart,
                sendTreePatches: sendTreePatches,
                disableGraphics: disableGraphics,
                enableInvisibleGraphics: enableInvisibleGraphics,
            }));
        }
        catch (error) {
            dispatch(globalActions.error(error, { owner: 'worker', worker: undefined }));
        }
    };
}
exports.handleWorker = handleWorker;
/**
 * Spawns a local worker instance and awaits its ready state
 *
 * @param {number = 3} tries
 */
function spawnWorker(tries) {
    var _this = this;
    if (tries === void 0) { tries = 3; }
    return function (dispatch, getState, server) { return __awaiter(_this, void 0, void 0, function () {
        var id, spawned, _a, exec, execArgs, stdout, workerTimeout, showConsole, ccProcess, worker, unsub_1, error_2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    id = guid_1.default.raw();
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 6, , 7]);
                    spawned = getState().globals.spawned;
                    dispatch(globalActions.updateGlobals({ spawned: spawned + 1 }));
                    _a = getState().config, exec = _a.exec, execArgs = _a.execArgs, stdout = _a.stdout, workerTimeout = _a.workerTimeout, showConsole = _a.showConsole;
                    execArgs = __spreadArrays(execArgs, ["--id", "" + id]);
                    if (spawned)
                        dispatch(globalActions.info("spawning " + id, { owner: 'worker', worker: id }));
                    else
                        dispatch(globalActions.info("spawning " + id + "\n" + exec + " " + execArgs.join(' '), { owner: 'worker', worker: id }));
                    ccProcess = child_process_1.spawn(exec, execArgs, {
                        stdio: stdout ? 'pipe' : undefined,
                        shell: showConsole,
                        detached: showConsole,
                    });
                    if (stdout) {
                        ccProcess.stdout
                            .setEncoding('utf8')
                            .on('data', function (data) { return dispatch(globalActions.log(data.trim(), { owner: 'worker', worker: id })); });
                        ccProcess.stderr
                            .setEncoding('utf8')
                            .on('data', function (data) { return dispatch(globalActions.error(data.trim(), { owner: 'worker', worker: id })); });
                    }
                    ccProcess.on('error', function (error) { return dispatch(globalActions.error(error, { owner: 'worker', worker: id })); });
                    return [4 /*yield*/, helpers_1.awaitState(server.store, function (s) { return s.collections.workers; }, function (workers) { return workers.find(function (w) { return w === id; }); }, workerTimeout)];
                case 2:
                    worker = _b.sent();
                    if (!worker) return [3 /*break*/, 3];
                    dispatch(updateWorker(worker, { process: ccProcess }));
                    unsub_1 = helpers_1.subscribe(server.store, function (state) { return state.workers[id] && !state.workers[id].alive; }, function () { return unsub_1() || (getState().globals.running && dispatch(spawnWorker())); });
                    return [2 /*return*/, id];
                case 3:
                    dispatch(globalActions.error("worker died coming up", { owner: 'worker', worker: id }));
                    ccProcess && ccProcess.kill();
                    ccProcess = undefined;
                    if (!(tries > 0 && getState().globals.running)) return [3 /*break*/, 5];
                    return [4 /*yield*/, delay_1.default(2000)];
                case 4: 
                // TODO: what does this line mean???
                // @ts-ignore
                return [2 /*return*/, (_b.sent()) || (getState().globals.running && dispatch(spawnWorker(tries - 1)))];
                case 5: return [3 /*break*/, 7];
                case 6:
                    error_2 = _b.sent();
                    dispatch(globalActions.error(error_2, { owner: 'worker', worker: id }));
                    return [3 /*break*/, 7];
                case 7: return [2 /*return*/];
            }
        });
    }); };
}
exports.spawnWorker = spawnWorker;
//# sourceMappingURL=worker.js.map