"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var types = __importStar(require("../types"));
var initial = {
    executable: 'ClassCADInstance.exe',
    configurationData: 'CADApplication.ini',
    output: path_1.default.resolve('./node_modules/@awv/classcad_cadapplication'),
    protocol: 'http',
    serverOptions: {},
    ip: 'localhost',
    privatePort: 0,
    publicPort: 8181,
    binary: true,
    multipart: true,
    compression: true,
    sendTreePatches: true,
    stdout: false,
    instances: 0,
    secureApi: false,
    debug: true,
    showConsole: false,
    stateDebounce: 500,
    maxStates: 10,
    workerTimeout: 1000 * 15,
    restTimeout: 1000 * 60 * 2,
    pingTimeout: 1000 * 5,
    pingInterval: 1000 * 25,
    collectResultsOnly: true,
    logExpirationDays: 5,
    disableGraphics: false,
    enableInvisibleGraphics: false,
    enableTaskSalvaging: true,
    exec: '',
    execArgs: [],
};
function default_1(state, props) {
    if (state === void 0) { state = initial; }
    var type = props.type, other = __rest(props, ["type"]);
    switch (type) {
        case types.updateConfig:
            var merge = __assign(__assign({}, state), other);
            var output = merge.output, executable = merge.executable, privatePort = merge.privatePort, secureApi = merge.secureApi, binary = merge.binary, showConsole = merge.showConsole, debug = merge.debug;
            var isWine = ['win32', 'linux'].indexOf(process.platform) < 0;
            var binpath = path_1.default.join(output, executable);
            var execArgs = isWine ? [binpath] : [];
            execArgs = __spreadArrays(execArgs, ['socketclient', "--port", "" + privatePort, '--ccwss']);
            secureApi && execArgs.push('--sapi');
            binary && execArgs.push('--binary');
            showConsole && execArgs.push('--console');
            debug && execArgs.push('--debug');
            var exec = isWine ? 'wine64' : binpath;
            return __assign(__assign({}, merge), { exec: exec, execArgs: execArgs });
    }
    return state;
}
exports.default = default_1;
//# sourceMappingURL=config.js.map