"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var defaults_1 = __importDefault(require("../../defaults"));
var types = __importStar(require("../types"));
function default_1(state, props) {
    if (state === void 0) { state = []; }
    // 'worker' field should not be present, or else it should not mutate global tasks
    // When the field is present it would mean that the task is managed as a worker-task
    // The only exception is claimWorker, which removes global tasks now belonging to a worker
    if (props.worker && props.type !== types.claimWorker)
        return state;
    switch (props.type) {
        case types.pushTask:
            return __spreadArrays(state, [
                {
                    id: props.task,
                    user: props.user,
                    commands: props.commands,
                    promise: props.promise,
                    resolve: props.resolve,
                    reject: props.reject,
                    timestamp: props.timestamp || defaults_1.default.now(),
                    duration: 0,
                    results: [],
                    streamData: {},
                },
            ]);
        case types.claimWorker:
            return state.filter(function (t) { return t.user !== props.user; });
        case types.removeTask:
            return state.filter(function (t) { return t.id !== props.task; });
        case types.updateTask:
            return state.map(function (t) {
                return t.id === props.task
                    ? __assign(__assign({}, t), { results: __spreadArrays(t.results, props.results), streamData: __assign(__assign({}, t.streamData), props.streamData) }) : t;
            });
    }
    return state;
}
exports.default = default_1;
//# sourceMappingURL=tasks.js.map