"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var defaults_1 = __importDefault(require("../../defaults"));
var types = __importStar(require("../types"));
var tasks_1 = __importDefault(require("./tasks"));
function default_1(state, props) {
    var _a, _b, _c, _d, _e;
    if (state === void 0) { state = {}; }
    var worker = props.worker, other = __rest(props, ["worker"]);
    switch (props.type) {
        case types.addWorker:
            return __assign(__assign({}, state), (_a = {}, _a[worker] = {
                id: worker,
                socket: props.socket,
                process: props.process,
                lastUser: undefined,
                occupied: false,
                alive: true,
                tasks: [],
                timestamp: defaults_1.default.now(),
                sequence: Promise.resolve(),
                resolve: undefined,
            }, _a));
        case types.updateWorker:
            return __assign(__assign({}, state), (_b = {}, _b[worker] = __assign(__assign({}, state[worker]), props.updates), _b));
        case types.removeWorker:
            return lodash_1.default.omit(state, worker);
        case types.claimWorker:
            return __assign(__assign({}, state), (_c = {}, _c[worker] = __assign(__assign({}, state[worker]), { tasks: __spreadArrays(state[worker].tasks, props.tasks), occupied: true, lastUser: props.user || state[worker].lastUser, timestamp: defaults_1.default.now(), sequence: props.sequence || state[worker].sequence, resolve: props.resolve || state[worker].resolve }), _c));
        case types.releaseWorker:
            return __assign(__assign({}, state), (_d = {}, _d[worker] = __assign(__assign({}, state[worker]), { occupied: false, timestamp: defaults_1.default.now() }), _d));
        case types.removeTask:
        case types.pushTask:
        case types.updateTask:
            if (!worker)
                return state;
            // We re-use the task-reducer here, but since both places now share the same semantics
            // we have to extract the 'worker' field in order to not disturb global task reducing
            return __assign(__assign({}, state), (_e = {}, _e[worker] = __assign(__assign({}, state[worker]), { tasks: tasks_1.default(state[worker].tasks, other), timestamp: defaults_1.default.now() }), _e));
    }
    return state;
}
exports.default = default_1;
//# sourceMappingURL=workers.js.map